<?php
if (!defined('OLDPAL_MYSQL_PHP')) {
define('OLDPAL_MYSQL_PHP', null);



//
// +----------------------------------------------------------------------+
// | PHP version 4.0                                                      |
// +----------------------------------------------------------------------+
// +----------------------------------------------------------------------+
// | Authors: Jacky Ko
// +----------------------------------------------------------------------+
//
// $Id: oldpal_mysql.php,v 1.1 2003/10/19 08:01:11 root Exp root $
//
// Database independent query interface definition for Oldpal PHP
// extension.
//

include_once('DB.php');
include_once('DB/oldpal_common.php');
include_once('DB/mysql.php');

class DB_oldpal_mysql extends DB_mysql
{
	var $oldpal_owner = '';
	var $oldpal_service = '';
	var $oldpal_dbid = '';  // Dummy
	var $oldpal_dbtype = '';
	var $oldpal_host = '';
	var $oldpal_database = '';
	var $SQLCommand = '';

	var $debugLevel = 0;

	function DB_oldpal_mysql()
	{
		$this->DB_mysql();
	}


	// For non-CROFT version, look for CROFT info from the arglist.
	function connect($dsn = '', $persistent = false, $owner = '', $service = '')
	{
if ($this->debugLevel) printf("<b>function</b> %s::connect<br>\n", get_class($this));
		global $BeeCroft;
		if (isset($BeeCroft))
		{
			list ($this->oldpal_owner, $this->oldpal_service)
				= $BeeCroft->getOwnerService();
			list ($this->oldpal_dbid, $this->oldpal_dbtype, $this->oldpal_host, $this->oldpal_database, $AuthUsername, $AuthPassword)
				= $BeeCroft->getAllDataInfo();
		} else
		{
			$this->oldpal_owner = $owner;
			$this->oldpal_service = $service;

			if(is_array($dsn))
			{
				$dsninfo = &$dsn;
			} else
			{
				$dsninfo = DB::parseDSN($dsn);
			}
			if (!$dsninfo || !$dsninfo['phptype'])
			{
				return $this->raiseError(); 
			}
			$this->oldpal_dbtype = $dsninfo['phptype'];
			$this->oldpal_host = $dsninfo['hostspec'] ? $dsninfo['hostspec'] : 'localhost';
			$this->oldpal_database = $dsninfo['database'];
			$AuthUsername = $dsninfo['username'];
			$AuthPassword = $dsninfo['password'];
		}

if ($this->debugLevel)
{
	printf("\$oldpal_owner = [%s]<br>\n", $this->oldpal_owner);
	printf("\$oldpal_service = [%s]<br>\n", $this->oldpal_service);
	printf("\$oldpal_dbid = [%s]<br>\n", $this->oldpal_dbid);
	printf("\$oldpal_dbtype = [%s]<br>\n", $this->oldpal_dbtype);
	printf("\$oldpal_host = [%s]<br>\n", $this->oldpal_host);
	printf("\$oldpal_database = [%s]<br>\n", $this->oldpal_database);
	printf("\$AuthUsername = [%s]<br>\n", $AuthUsername);
	printf("\$AuthPassword = [***]<br>\n", $AuthPassword);
}

		$connect_function = $persistent ? 'mysql_pconnect' : 'mysql_connect';
		if ($this->oldpal_host && $AuthUsername && $AuthPassword)
		{
if ($this->debugLevel) printf("%s::connect host($this->oldpal_host) user($AuthUsername) password(***)<br>\n", get_class($this));
			$conn = @$connect_function($this->oldpal_host, $AuthUsername, $AuthPassword);
		} elseif ($this->oldpal_host && $AuthUsername)
		{
if ($this->debugLevel) printf("%s::connect host($this->oldpal_host) user($AuthUsername)<br>\n", get_class($this));
			$conn = @$connect_function($this->oldpal_host, $AuthUsername);
		} else
		{
if ($this->debugLevel) printf("%s::connect host($this->oldpal_host)<br>\n", get_class($this));
			$conn = @$connect_function($this->oldpal_host);
		}

		if ($conn === false)
		{
if ($this->debugLevel) printf("%s::connect returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		} else
		{
			if ($this->oldpal_database)
			{
if ($this->debugLevel) printf("%s::connect select $this->oldpal_database<br>\n", get_class($this));
				@mysql_select_db($this->oldpal_database, $conn);
			} else
			{
if ($this->debugLevel) printf("%s::connect select_db returns ERROR<br>\n", get_class($this));
				return $this->raiseError();
			}
			$this->connection = $conn;
if ($this->debugLevel) printf("%s::connect returns DB_OK<br>\n", get_class($this));
			return DB_OK;
		}
	}

	function disconnect()
	{
if ($this->debugLevel) printf("<b>function</b> %s::disconnect<br>\n", get_class($this));
		return @mysql_close($this->connection);
	}

	function setDebugLevel($level)
	{
//if ($this->debugLevel || $level) printf("<b>function</b> %s::setDebugLevel([$level])<br>\n", get_class($this));
		$this->debugLevel = $level;
		return DB_OK;
	}

	function numRows($result)
	{
		$rows = @mysql_num_rows($result);
		if ($rows < 0)
		{
if ($this->debugLevel) printf("%s::numRows returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		}
if ($this->debugLevel) printf("%s::numRows returns $rows<br>\n", get_class($this));
		return $rows;
	}

	function seekRow($result, $rownum = 0)
	{
		if (!@mysql_data_seek($result, $rownum))
		{
if ($this->debugLevel) printf("%s::seekRow returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		}
if ($this->debugLevel) printf("%s::seekRow returns DB_OK<br>\n", get_class($this));
		return DB_OK;
	}

	function nextSeq($table)
	{
		return -1;
	}

	function lastSeq()
	{
		return @mysql_insert_id($this->connection);
	}

	function commonRegExp($Str)
	{
		$ret = $Str;
		$ret = ereg_replace("\.", "\\.", $ret);
		$ret = ereg_replace("\?", ".", $ret);
		$ret = ereg_replace("\*", $this->wildRegExp(), $ret);
		$ret = "^" . $ret . "$";
		return $ret;
	}

	function commonRegExpWild($Str)
	{
		return ereg_replace("\*", $this->wildRegExp(), $Str);
	}

	function operatorRegExp()
	{
		return "rlike";
	}

	function wildRegExp()
	{
		return ".*";
	}


	function tableList()
	{
		$result = @mysql_list_tables($this->oldpal_database, $this->connection);
		$rows = @mysql_num_rows($result);
		$ret = array();
		for ($i = 0; $i < $rows; $i++) $ret[] = @mysql_tablename($result, $i);
		return $ret;
	}


	function fieldList($tablename, $withAttr = false)
	{
		$ret = array();

		if (!is_string($tablename)) $result = $tablename;
		else $result = @mysql_list_fields($this->oldpal_database, $tablename, $this->connection);

		$fields = @mysql_num_fields($result);
		for ($i = 0; $i < $fields; $i++)
		{
			if (!$withAttr)
			{
				$ret[] = @mysql_field_name($result, $i);
			} else
			{
				$attr = array
				(
					'name' => @mysql_field_name($result, $i),
					'type' => @mysql_field_type($result, $i),
					'len' => @mysql_field_len($result, $i),
					'flags' => @mysql_field_flags($result, $i),
				);
				$ret[] = $attr;
			}
		}
		return $ret;
	}



// Common functions for Oldpal Object

	function getDebugLevel()
	{
		return $this->debugLevel;
	}

	function getOwner()
	{
		return $this->oldpal_owner;
	}

	function getService()
	{
		return $this->oldpal_service;
	}

	function action($oldpal_resource, $oldpal_action = 'select', $oldpal_getSQL = false)
	{
if ($this->debugLevel) printf("%s::action([$oldpal_resource], [$oldpal_action], [$oldpal_getSQL])<br>\n", get_class($this));
		return DB_oldpal_common::action($oldpal_resource, $oldpal_action, $oldpal_getSQL);
	}

	function display($oldpal_resource, $oldpal_result = -1)
	{
		return DB_oldpal_common::display($oldpal_resource, $oldpal_result);
	}

	function getSelectList($qry, $fmt = '%s:%s', $optsep = '|')
	{
		return DB_oldpal_common::getSelectList($this, $qry, $fmt, $optsep);
	}

	function getSQL($sqlAction)
	{
		return DB_oldpal_common::getSQL($sqlAction);
	}

	function setSQL($sql)
	{
		return DB_oldpal_common::setSQL($sql);
	}

	function quoteString($string)
	{
		return DB_oldpal_common::quoteString($string);
	}

	function unquoteString($string)
	{
		return DB_oldpal_common::unquoteString($string);
	}
}




}  // OLDPAL_MYSQL_PHP
?>
