<?php include("bee/compiler.php"); return; ?>
<script language="bee">
/************************************************************
 *	dbobj_dump: Dump the database object
 *
 *	arg%fieldlist = the name of the fields to display in the format of
 *		key=>val where key is the caption and value is the field name.
 *		If the caption is preceeded by '!', val is a derived value with
 *			@f for value, where f is the field name;
 *	arg%pagesize = the maximum number of records in a page
 *	arg%form = the input tag attributes
 *		@key for the value of the key field
 *		(form is displayed only if the object got the keyfield defined)
 *		@f where f is the field name will be substituted with the field value
 *	arg%tr = the tr tag attributes (in addition to the color stripping)
 *		@f where f is the field name will be substituted with the field value
 *	arg%td = the td tag attributes ({arg%td:} if specified is the default for fields without arg%td)
 *	arg%format = the field formats (read-only fields only)
 *	arg%hiddenvalue = the array of values that are hidden, indexed by fieldname
 *	arg%readonlyvalue = the array of values that are read-only, indexed by fieldname
 *	arg%rowbgcolor = the array of color code for rows (cycling through)
 *	arg%table = the table tag attributes
 ************************************************************/

function dbobj_dump pagesize=10 rowbgcolor="(array)#e0ffff,#ffffff"
{
/*
display "dbobj_dump: arg%function={arg%function|list}<br>\n";
display "this%table=[{this%table}]<br>\n";
display "this%status=[{this%status}]<br>\n";
display "this%numrecs=[{this%numrecs}]<br>\n";
display "arg%fieldlist=[{arg%fieldlist|list}]<br>\n";
display "arg%form=[{arg%form|list}]<br>\n";
display "arg%td=[{arg%td|list}]<br>\n";
 */
	//if ('{this%table}' == '' || '{this%status}' > 0 || '{this%numrecs}' <= 0) return;
	if ('{this%table}' == '' || '{this%status}' > 0) return;
	// Now we got a proper table with OK status and at least some records.

	var hl = (var)arg%rowbgcolor;  // Alternative highlighting
	if ({#hl} <= 1) var hl = "(array){hl|shift}";
	var hli = 0;  // Highlight index

	var fieldlist = "(var)arg%fieldlist";
	if ({#fieldlist} == 0) var fieldlist = "(var)this%fieldlist";
	
	display "<table {arg%table}>\n";

	var headerDone = 0;

	foreach maxiter="{arg%pagesize}" ((db)this as rec)
	{
		// If fieldlist is still empty, this is the last chance
		if ({#fieldlist} == 0) var fieldlist = (var)rec conv=keys;

		trAttr = "{arg%tr}";
		foreach (this%fieldlist) {
			var trAttr = "{trAttr|replace:@{foreach},{rec:{foreach}|escape:commas}}";
		}

		if (!'{headerDone}') {
			// Display the header
			display "<tr bgcolor=#808080 {trAttr}>\n";
			foreach (fieldlist)
			{
				if ({foreach:key|foundre:^[0-9]}) var caption = "{foreach}";
				else var caption = "{foreach:key|replacere:^!}";
				display "<td><font color=#ffffff>{caption|words}</font></td>\n";
			}
			display "</tr>\n";
			var headerDone = 1;
		}

		display '<tr valign=top bgcolor="{hl:{hli}}" {trAttr}>\n';
		//var fldcnt = 0;
		var keyValue = "{rec:{this%keyfield}}";
		foreach (fieldlist as fld)
		{
			var TDattr = "{arg%td:{fld:key|replacere:^!}}";
			if ({#TDattr:} == 0) var TDattr = "{arg%td}";
			display "<td {TDattr}>";
			//display "{fld:key}:" conv="if:'{fld:key}' != '{this%fieldlist:{fldcnt}}'";
			//display "{fld|{{name}%decode:{fld:key}}}</td>\n";
			if ({fld:key|foundre:^!})
			{
				var fldValue = "{fld}";
				foreach (this%fieldlist) {
					var fldValue = "{fldValue|replace:@{foreach},{rec:{foreach}|escape:commas}}";
				}
				display "{fldValue}";
			} else
			{
				var fldFormatted = "{rec:{fld}}";
				if ({#arg%format:{fld}}) var fldFormatted = "{arg%format:{fld}|replace:@fldval,{fldFormatted|escape:commas}}";
				if ({#keyValue:} == 0 || ('{fld}' != '{this%keyfield}' && {#arg%form:{fld}} == 0))
				{
					display '{fldFormatted}';
				} else
				{
					fmAttr = "{arg%form:{fld}|replace:@key,{keyValue|escape:commas}}";
					foreach (this%fieldlist) {
						var fmAttr = "{fmAttr|replace:@{foreach},{rec:{foreach}|escape:commas}}";
					}
					var hiddenFld = '<input type=hidden name="{fld}_{keyValue}" value="{rec:{fld}|replace:\\\\",&quot;}">';
					var readonlyFld = '{hiddenFld}{fldFormatted}';
					var shownFld = '<input type=text name="{fld}_{keyValue}" value="{rec:{fld}|replace:\\\\",&quot;}" {fmAttr}>';
					if ({arg%hiddenvalue:{fld}|isset} && '{rec:{fld}|escape:single}' == '{arg%hiddenvalue:{fld}}')
						display '{hiddenFld}';
					else if ({arg%readonlyvalue:{fld}|isset} && '{rec:{fld}|escape:single}' == '{arg%readonlyvalue:{fld}}')
						display '{readonlyFld}';
					else if ('{fld}' == '{this%keyfield}')
						display '{readonlyFld}';
					else
						display '{shownFld}';
				}
			}
			display "</td>\n";
			
			//var fldcnt = "(expr){fldcnt} + 1";
		}
		display "</tr>\n";

		var hli conv="inc";
		if ({#hl:{hli}} == 0) var hli = 0;
	}
	display "</table>\n";
}


/************************************************************
 *	dbobj_matrix_dump: Dump the matrix
 ************************************************************/

function dbobj_matrix_dump
{
/*
display "this%matrix=[{this%matrix|list}]<br>\n";
display "this%keys=[{this%keys|list}]<br>\n";
display "this%fields=[{this%fields|list}]<br>\n";
 */
	if ({#this%matrix} == 0) return;
	if ({#this%keys} == 0) return;
	if ({#this%fields} == 0) return;

	parent "{this%matrix}%";

	display "<table>\n<tr valign=top><td>Key</td>\n";
	foreach (this%fields) display "<td>{foreach}</td>\n";
	display "</tr>\n";

	foreach (this%keys as key)
	{
		display "<tr valign=top><td>{key}</td>\n";
		foreach (this%fields as field) display "<td>{{this%matrix}%{key}:{field}}</td>\n";
	}
	
	display "</table>\n";
}
</script>
