<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	menu: Menu Object
 *
 *	arg%table = the table name (default is the object name {arg%this})
 *
 *	Object variables:
 *	%fmtnode	the format of the node
 *	%fmtcurrent	the format of the current node (default %fmtnode)
 *	%fmtopen	the format of opened nodes (default %fmtcurrent)
 *	%fmtclose	the format of closed nodes (default %fmtopen)
 *	%fmtcurrentparent	the format of the current node if it's a parent (default %fmtcurrent)
 *	%fmtopenparent		the format of opened parent nodes (default %fmtopen)
 *	%fmtcloseparent		the format of closed parent nodes (default %fmtclose)
 *
 *	All other object variables are "inherited" from the database command
 ************************************************************/

function menu
{
	var this%table = "{arg%table}";
	if ({#this%table:} == 0) var this%table = "{arg%this}";
	var this%matrix = "{arg%this}_matrix";
	var this%dbid = "{arg%dbid}";

	var this%status = 0;
	var this%message = "";
	
	var this%function:query = "dbobj_query";
	var this%function:select = "dbobj_action";
	var this%function:update = "dbobj_action";
	var this%function:insert = "dbobj_action";
	var this%function:delete = "dbobj_action";
	var this%function:group = "dbobj_group";
	var this%function:matrixdump = "dbobj_matrix_dump";
	var this%function:dump = "dbobj_dump";
}


/************************************************************
 *	dbobj_query: Send a query to the database
 *
 *	arg%query (default) = the query string
 *	arg%seek = the seek parameter for the database command
 ************************************************************/

function dbobj_query
{
	//parent "{arg%this}%";
	if ({#arg%function:seek} > 0) var param%database:seek = "{arg%function:seek}";
	database this query="{arg%query}" dbid="{this%dbid}";
	//var session%{arg%this} = "(var)session%this";
	//var this%status = "{status%database}";
	//var this%message = "{message%database}";
}


/************************************************************
 *	dbobj_action: Called via dbobj%select, dbobj%update, dbobj%insert, dbobj%delete
 *		to carry out the corresponding database command
 *
 *	arg%thisfunction = the action parameter for the database command
 *	arg%seek = the seek parameter for the database command
 ************************************************************/

function dbobj_action
{
	//parent "{arg%this}%";
	parent "{this%matrix}%";
	if ({#arg%function:seek} > 0) var param%database:seek = "{arg%function:seek}";
	database this matrix="{this%matrix}" action="{arg%thisfunction}" dbid="{this%dbid}";
	//var session%{arg%this} = "(var)session%this";
	//var this%status = "{status%database}";
	//var this%message = "{message%database}";
}


/************************************************************
 *	dbobj_group: Perform the "group" command on the specified
 *		variable into the class specified by this%matrix and
 *		set the group result into the object.
 *
 *	arg%group (default) = the variable to be grouped.
 *	If this%matrix is blank, set it to {arg%this}_matrix
 ************************************************************/

function dbobj_group
{
	var gvar = "{arg%{arg%thisfunction}}";
	if ({#gvar:} == 0) return;
	parent "{gvar}";
	
	if ({#this%matrix} == 0) var this%matrix = "{arg%this}_matrix";

	// The "group" command always operates in the local context.
	// Needs to link the variables it changes to the parent.
	parent "{arg%this}%";
	parent "{this%matrix}%";
	group "{gvar}" matrix="{this%matrix}" result="{arg%this}";
}


/************************************************************
 *	dbobj_matrix_dump: Dump the matrix
 ************************************************************/

function dbobj_matrix_dump
{
/*
display "this%matrix=[{this%matrix|list}]<br>\n";
display "this%keys=[{this%keys|list}]<br>\n";
display "this%fields=[{this%fields|list}]<br>\n";
 */
	if ({#this%matrix} == 0) return;
	if ({#this%keys} == 0) return;
	if ({#this%fields} == 0) return;

	parent "{this%matrix}%";

	display "<table>\n<tr valign=top><td>Key</td>\n";
	foreach (this%fields) display "<td>{foreach}</td>\n";
	display "</tr>\n";

	foreach (this%keys as key)
	{
		display "<tr valign=top><td>{key}</td>\n";
		foreach (this%fields as field) display "<td>{{this%matrix}%{key}:{field}}</td>\n";
	}
	
	display "</table>\n";
}


/************************************************************
 *	dbobj_dump: Dump the database object
 *
 *	arg%fieldlist = the name of the fields to display
 *	arg%pagesize = the maximum number of records in a page
 *	arg%form = the input tag attributes
 *	arg%td = the td tag attributes
 ************************************************************/

function dbobj_dump pagesize=10
{
/*
display "dbobj_dump: arg%function={arg%function|list}<br>\n";
display "this%table=[{this%table}]<br>\n";
display "this%status=[{this%status}]<br>\n";
display "this%numrecs=[{this%numrecs}]<br>\n";
display "arg%fieldlist=[{arg%fieldlist|list}]<br>\n";
display "arg%form=[{arg%form|list}]<br>\n";
display "arg%td=[{arg%td|list}]<br>\n";
 */
	//if ('{this%table}' == '' || '{this%status}' > 0 || '{this%numrecs}' <= 0) return;
	if ('{this%table}' == '' || '{this%status}' > 0) return;
	// Now we got a proper table with OK status and at least some records.

	var hl = "(array)#e0ffff,#ffffff";  // Alternative highlighting
	var hli = 0;  // Highlight index

	var fieldlist = "(var)arg%fieldlist";
	if ({#fieldlist} == 0) var fieldlist = "(var)this%fieldlist";
	
	display "<table>\n";

	// Display the header
	display "<tr bgcolor=#808080>\n";
	foreach (fieldlist)
	{
		var caption = "{foreach:key}";
		if ({foreach:key|foundre:^[0-9]} > 0) var caption = "{foreach}";
		display "<td><font color=#ffffff>{caption}</font></td>\n";
	}
	display "</tr>\n";

	foreach maxiter="{arg%pagesize}" ((db)this as rec)
	{
		display '<tr valign=top bgcolor="{hl:{hli}}">\n';
		//var fldcnt = 0;
		var keyValue = "{rec:{this%keyfield}}";
		foreach (fieldlist as fld)
		{
			display "<td {arg%td:{fld}}>";
			//display "{fld:key}:" conv="if:'{fld:key}' != '{this%fieldlist:{fldcnt}}'";
			//display "{fld|{{name}%decode:{fld:key}}}</td>\n";
			if ({#keyValue:} == 0 || ('{fld}' != '{this%keyfield}' && {#arg%form:{fld}} == 0))
			{
				display '{rec:{fld}}';
			} else
			{
				var hiddenFld = '<input type=hidden name="{fld}_{keyValue}" value="{rec:{fld}|replace:\\\\",&quot;}">';
				var readonlyFld = '{hiddenFld}{rec:{fld}}';
				var shownFld = '<input type=text name="{fld}_{keyValue}" value="{rec:{fld}|replace:\\\\",&quot;}" {arg%form:{fld}|replace:@key,{keyValue}}>';
				if ({arg%hiddenvalue:{fld}|isset} && '{rec:{fld}}' == '{arg%hiddenvalue:{fld}}')
					display '{hiddenFld}';
				else if ({arg%readonlyvalue:{fld}|isset} && '{rec:{fld}}' == '{arg%readonlyvalue:{fld}}')
					display '{readonlyFld}';
				else if ('{fld}' == '{this%keyfield}')
					display '{readonlyFld}';
				else
					display '{shownFld}';
			}
			display "</td>\n";
			
			//var fldcnt = "(expr){fldcnt} + 1";
		}
		display "</tr>\n";

		if ({hli} > 0) var hli = 0;
		else var hli = "(expr){hli}+1";
	}
	display "</table>\n";
}
</script>
