<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	tree_dumpsubtree: Dump the subtree (recursively)
 *
 *	arg%node = the index of the root of the subtree (compulsory)
 *	arg%level = the level of the root from the main tree (for indentation)
 *	arg%maxlevels = the maximum number of levels to display
 ************************************************************/

function tree_dumpsubtree level=0 maxlevels=20
{
	if ({#arg%maxlevels:} && {arg%level} > {arg%maxlevels})
		return status=2 message="Maximum level '{arg%maxlevels}' is reached";

	// Allow blank root
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' is missing";
	var node = "{arg%node}";

	display "{this%indent|repeat:{arg%level}}";
	if ('{node}' == '{this%current}') display "<b>[{node}]</b>";
	else display "[{node}]";
	display "<br>\n";

	var nextLevel = "{arg%level|inc}";
	this%tree_children node="{node}";

	// Beware of recursiveness!
	foreach (result%tree_children) {
		this%tree_dumpsubtree node="{foreach}" level="{nextLevel}" maxlevels="{arg%maxlevels}";
		if ({status%tree_dumpsubtree})
			return status="{status%tree_dumpsubtree}" message="{message%tree_dumpsubtree}";
	}
}


/************************************************************
 *	tree_dump: Dump the tree from the set root
 *
 *	arg%maxlevels = the maximum number of levels to display
 ************************************************************/

function tree_dump maxlevels=10
{
	this%tree_dumpsubtree node="{this%root}" level=0 maxlevels="{arg%maxlevels}";
	return status="{status%tree_dumpsubtree}" message="{message%tree_dumpsubtree}";
}
</script>
