<?php include("bee/compiler.php"); return; ?>
<script language="bee">

// arg%node - The root of the subtree to export
// arg%tree - The name of a tree in the parent scope to export the subtree to
function tree_export
{
	var expTree = "{arg%tree}";
	if ({#expTree:} == 0) return status=1 message="Argument 'tree' is missing";
	parent "{expTree}%";

	// Allow blank node
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) return status=2 message="Argument 'node' is missing";

	this%tree_descendants node="{node}";
	if ({status%tree_descendants}) return status="{status%tree_descendants}" message="{message%tree_descendants}";
	var subtreeNodes = "(var)result%tree_descendants";

	var subtreeParents = "(array)";
	foreach (subtreeNodes) {
		if ({this%parent:{foreach}|isset}) var subtreeParents:{foreach} = "{this%parent:{foreach}}";
	}

	{expTree}%reset parent="(var)subtreeParents" root="{node}";
}


// arg%tree - The name of a tree in the parent scope to import from
// arg%childof - The imported tree will become the child of {arg%childof}
// arg%elderof - The imported tree will become the elder of {arg%elderof}
// arg%youngerof - The imported tree will become the younger of {arg%youngerof}
// (If childof is specified, elderof and youngerof will be ignored; if elderof
//	is specified, youngerof will be ignored.  If none of the three are specified,
//	no import is done.
// result%function - The node map (before import => after import)
function tree_import
{
	var impTree = "{arg%tree}";
	if ({#impTree:} == 0) return status=1 message="Argument 'tree' is missing";
	parent "{impTree}%";

	var op = "";
	if ({arg%function:childof|isset}) {
		var op = "tree_addchild";
		var to = "{arg%childof}";
	} else if ({arg%function:elderof|isset}) {
		var op = "tree_addelder";
		var to = "{arg%elderof}";
	} else if ({arg%function:youngerof|isset}) {
		var op = "tree_addyounger";
		var to = "{arg%youngerof}";
	}
	if ({#op:} == 0) return status=2 message="None of the argument 'childof', 'elderof' and 'youngerof' are specified";

	{impTree}%tree_getroot;
	var impRoot = "{result%tree_getroot}";

	{impTree}%tree_getallnodes;
	var impNodes = "(var)result%tree_getallnodes";

	this%tree_getallnodes;
	if ({status%tree_getallnodes}) return status="{status%tree_getallnodes}" message="{message%tree_getallnodes}";
	var myNodes = "(var)result%tree_getallnodes";

	var newNodeValues = "(var)myNodes" conv="newvalues:{#impNodes}";

	// nodeMap maps impTree=>this
	var nodeMap = "(array)";
	foreach (impNodes) var nodeMap:{foreach} = "(var)newNodeValues" conv="shift";
	// Nothing for {impRoot} except for "child".
	foreach ({impTree}%parent)
		if ('{foreach:key}' != '{impRoot}')
			var this%parent:{nodeMap:{foreach:key}} = "{nodeMap:{foreach}}";
	foreach ((array){class%list:{impTree}} as child_imp) {
		if ({child_imp|foundre:^child_} == 0) continue;
		var imp = "{child_imp|replacere:^child_}";
		var this%child_{nodeMap:{imp}} = "(array)";
		foreach ({impTree}%{child_imp}) var this%child_{nodeMap:{imp}} conv="push:{nodeMap:{foreach}}";
	}
	//foreach ({impTree}%child as imp)
	//	var this%child:{nodeMap:{imp:key}} = "{nodeMap:{imp}}";
	
	this%{op} node="{nodeMap:{impRoot}}" to="{to}";
	if ({status%{op}}) return status="{status%{op}}" message="{message%{op}}";
	
	var result%function = "(var)nodeMap";
}
</script>
