<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	xml_searchattr: Search based on criteria about attributes
 *		and return the node and attribute indexes if found
 *		(Recursive algorithm)
 *
 *	arg%node - search the subtree under this node (default is {this%root})
 *	arg%criteria - an array containing the name=value pairs to search
 *		The "name" in the pair can be "value", "namespace", "localpart" or "prefix"
 *		e.g. localpart=>StockCode,value=>OMW,namespace=>http://example.com
 *		Default is "match all".
 *	arg%count - the maximum number of first matched attributes to return
 *		Search will stop when "count" attributes are found.  Default is 1.
 *		Blank means all.
 *	arg%level - the maximum number of level going down the tree hierarchy.
 *		Default is 1.  Blank means all.
 *	result%function - matched node-attribute pairs (comma separated)
 ************************************************************/

function xml_searchattr count=1 level=1
{
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) var node = "{this%root}";

	var criteria = "(array)";	
	foreach (arg%criteria) var criteria:{foreach:key|lowercase} = "{foreach}";

	var count = "{arg%count}";
	var level = "{arg%level}";

	foreach (this%attr_value_{node} as attr) {
		var matched = 1;
		foreach (criteria) {
			if ("{this%attr_{foreach:key}_{node}:{attr}}" != "{foreach}") {
				var matched = 0;
				break;
			}
		}

		if (matched) {
			// Make sure the first found is the default element.
			if ({#result%function} == 0) var result%function = "{node},{attr}";
			else var result%function conv="push:{node},{attr}";
			if ({#count:}) {
				var count conv="dec";
				if ({count} <= 0) return;
			}
		}
	}

	if ({#level:}) {
		var level conv="dec";
		if ({level} <= 0) return;
	}

	this%tree_children node="{node}";
	foreach (result%tree_children) {
		this%xml_searchattr node="{foreach}" criteria="(var)criteria"
			count="{count}" level="{level}";
		if ({#result%xml_searchattr}) {
			if ({#result%function} == 0) {
				var result%function = "(var)result%xml_searchattr";
			} else {
				// Use the values only, as the blank index may crash
				var newMatches = "(var)result%xml_searchattr" conv="values";
				var result%function = "(var)result%function" conv="merge:(var)newMatches";
			}
			if ({#count:}) {
				var count conv="dec:{#result%xml_searchattr}";
				if ({count} <= 0) return;
			}
		}
	}
}

/************************************************************
 *	xml_searchnode: Search based on criteria about nodes
 *		and return the node index if found
 *
 *	arg%node - search the subtree under this node (default is {this%root})
 *	arg%criteria - an array containing the name=value pairs to search
 *		The "name" in the pair can be "tag", "type", "level", "value",
 *		"namespace", "localpart" or "prefix"
 *		e.g. tag=>tns:StockItem,type=>open,namespace="http://example.com"
 *		Default is "match all".
 *	arg%count - the maximum number of first matched nodes to return
 *		Search will stop when "count" nodes are found.  Default is 1.
 *		Blank means all.
 *	arg%level - the maximum number of level going down the tree hierarchy.
 *		Default is 1.  Blank means all.
 *	result%function - indexes of matched nodes
 ************************************************************/

function xml_searchnode count=1
{
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) var node = "{this%root}";

	var criteria = "(array)";	
	foreach (arg%criteria) var criteria:{foreach:key|lowercase} = "{foreach}";

	var count = "{arg%count}";
	var level = "{arg%level}";

	var matched = 1;
	foreach (criteria) {
		if ("{this%xml_{node}:{foreach:key}}" != "{foreach}") {
			var matched = 0;
			break;
		}
	}

	if ({matched}) {
		// Make sure the first found is the default element.
		if ({#result%function} == 0) var result%function = "{node}";
		else var result%function conv="push:{node}";
		if ({#count:}) {
			var count conv="dec";
			if ({count} <= 0) return;
		}
	}

	if ({#level:}) {
		var level conv="dec";
		if ({level} <= 0) return;
	}

	this%tree_children node="{node}";
//	if (!{this%turbo}) {
	if (1) {
		foreach (result%tree_children) {
			this%xml_searchnode node="{foreach}" criteria="(var)criteria"
				count="{count}" level="{level}";
			if ({#result%xml_searchnode}) {
				if ({#result%function} == 0) {
					var result%function = "(var)result%xml_searchnode";
				} else {
					// Use the values only, as the blank index may crash
					var newMatches = "(var)result%xml_searchnode" conv="values";
					var result%function = "(var)result%function" conv="merge:(var)newMatches";
				}
				if ({#count:}) {
					var count conv="dec:{#result%xml_searchnode}";
					if ({count} <= 0) return;
				}
			}
		}
	} else {
</script>
<?php
		$result =& BEE_var("result%function");
		$count =& BEE_var("count:");
		$level =& BEE_var("level:");
		$arr = BEE_get("(var)result%tree_children");
		foreach ($arr as $foreach) {
			$param = array();
			$param["node"] = $foreach;
			$param["criteria"] = "(var)criteria";
			$param["count"] = $count;
			$param["level"] = $level;
			$param["this"] = "this";
			BEE_set("param%xml_searchnode", $param);
			BEE_do("xml_searchnode");
			$resultSearchNode =& BEE_var("result%xml_searchnode");
			if (count($resultSearchNode)) {
				if (count($result) == 0) {
					$result = $resultSearchNode;
				} else {
					// Use the values only, as the blank index may crash
					$newMatches = BEE_convert($resultSearchNode, "values");
					$result = array_merge($result, $newMatches);
				}
				if ($count != "") {
					$count -= count($resultSearchNode);
					if ($count <= 0) return;
				}
			}
		}
?>
<script language="bee">
	}
}
</script>
