<?php include("bee/compiler.php"); return; ?>
<script language="bee">
/*
 * tbody Object
 *	Enables application to display multiple records in a table form.  The
 *	core mechanism is a 3-element array: TBODY:Before, TBODY: and TBODY:After.
 *	The application display TBODY:Before first, then display every record either
 *	using listTEACUP (for values stored in TEA) or listTEAPOT (for values store
 *	in a data set.  Finally, the application display TBODY:After to finish the table.
 *
 *	There are four arguments:
 *
 *	arg%text: Text - Default is "text"
 *
 *	arg%type: Type - Default is "tbody"
 *	arg%category: Category - Default is ""
 *	arg%file: File - Default is "file"
 *
 *	The last 3 arguments are called the "path arguments".  They specify a
 *	storage under scheme%tbody/ where the TBODY array is stored, which is
 *	scheme%tbody/{type}/{category}/{file}&TBODY (after double slash removal).
 *
 *	Note: The reason we need 3 parts to form the path instead of just specifying the
 *	whole path is that the "category" part could be a path itself with inheritance.
 *	eg if "category" is product/book/scifi but no TBODY is found under it, you can use
 *	function findcategory to search upward "product/book", then "product".
 *	("findcategory" is not phantom mode aware.)
 *
 *	If you want to allow the TBODY table format to be editable via TEA, the Text will
 *	be stored under text%{type}/{category}/{file}&{text}, which is what the first argument
 *	is for.  The function gotTEA will detect that the text has just been saved via the
 *	TEA Editor, then the function process will be called to process the saved text.
 *	The function process will save the TBODY (save) to the scheme%tbody/ storage.
 *	(Note: Modifying the TEA Text does not affect the scheme%tbody/ until "process" is called.)
 *
 *	If you want to obtain the TBODY table format from an includable file, you must not
 *	specify the 3 "path arguments".  You can load the file using the function load
 *	with the "file" (default) argument.
 */
function tbody
{
	// The followings are common for both "scheme" and "file" models
	this%function:reset = "tbody_reset";
	this%function:process = "tbody_process";

	// The followings are for the "scheme" model only
	this%function:load = "tbody_load";
	this%function:save = "tbody_save";
	this%function:get = "tbody_get";
	this%function:getTBODY = "tbody_get";  // Backward compatibility
	this%function:gotTEA = "tbody_gotTEA";
	this%function:findcategory = "tbody_findcategory";

	// The followings are for displaying records (using TBODY:)
	this%function:listTEACUP = "tbody_listTEACUP";
	this%function:listTEAPOT = "tbody_listTEAPOT";

	this%text = "{arg%text|default:text}";

	// path arguments
	this%type = "";
	this%category = "";
	this%file = "";
	this%reset;

	if ('{arg%type}{arg%category}{arg%file}' != '') {
		// Any of the three is not blank
		this%type = "{arg%type|default:tbody}";
		this%category = "{arg%category}";  // blank category is OK
		this%file = "{arg%file|default:file}";
		this%reset;  // Do it again as "path arguments" have been changed.
					// (Cannot do it after the "if" as it will pick up the default values.)
	}
}


/*
 * reset
 *	Reinitialise the object after any of the four arguments
 *	(type, category, file and text) have changed.
 */
function tbody_reset
{
	this%path = "";
	if ('{this%type}{this%category}{this%file}' != '') {
		this%path = "{this%type}{this%category|precede:/}{this%file|precede:/}";
	}
	this%TBODY = (array);
}


/*
 * process
 *	Take arg%arg in and process it to look for THEAD and TBODY,
 *	then separate them into TBODY:Before, TBODY: and TBODY:After.
 *	If arg%splitter is specified, it will be used to delimit the
 *	3 elements (instead of using THEAD and TBODY tags).
 */
function tbody_process
{
	// Always use (var) to avoid variables in edittext being evaluated

	TBODY = "(array)";

	if ("{#arg%splitter:}") {
		arr = "(var)arg%arg:" conv="split:{arg%splitter}";
		if ({#arr} == 3) {
			TBODY:Before = (var)arr:#0;
			"TBODY:" = (var)arr:#1;
			TBODY:After = (var)arr:#2;
		}
	}

	if ({#TBODY} == 0) {
		TBODY:Before = "";
		"TBODY:" = "(var)arg%arg:" conv="unescape";
		TBODY:After = "";
/*
	tbPat = "[Tt][Bb][Oo][Dd][Yy]";
	arr = "(var)TBODY:" conv="match:^(.*)<{tbPat}>(.*)</{tbPat}>(.*)$";
	if ({#arr}) {
		TBODY:Before = (var)arr:#1;
		TBODY = (var)arr:#2;
		TBODY:After = (var)arr:#3;
	}
*/
		tb = "(var)TBODY:";
		tb = "(var)tb:" conv="replacere:<[Tt][Hh][Ee][Aa][Dd]>,<THEAD>";
		tb = "(var)tb:" conv="replacere:</[Tt][Hh][Ee][Aa][Dd]>,</THEAD>";
	
		// Optional syntax [THEAD] and [/THEAD]
		//tb = "(var)tb:" conv="replacere:\[[Tt][Hh][Ee][Aa][Dd]\],<THEAD>";
		//tb = "(var)tb:" conv="replacere:\[/[Tt][Hh][Ee][Aa][Dd]\],</THEAD>";
	
		tmp1 = "(var)tb:" conv="found:<THEAD>";
		tmp2 = "(var)tb:" conv="found:</THEAD>";
		if ('{tmp1}' && '{tmp2}') {
			// Got <THEAD> pair
			tb = "(var)tb:" conv="replacere:<[Tt][Bb][Oo][Dd][Yy]>,<TBODY>";
			tb = "(var)tb:" conv="replacere:</[Tt][Bb][Oo][Dd][Yy]>,</TBODY>";
	
			// Optional syntax [TBODY] and [/TBODY]
			//tb = "(var)tb:" conv="replacere:\[[Tt][Bb][Oo][Dd][Yy]\],<TBODY>";
			//tb = "(var)tb:" conv="replacere:\[/[Tt][Bb][Oo][Dd][Yy]\],</TBODY>";
	
			ln = "(var)tb:" conv="strlen";
			// bg is the position of the begin of TBODY; ed the end
			bg = "(var)tb:" conv="strpos:</THEAD>";
			if ('{bg}' >= 0) {
				var bg conv="+=:8";
				bg = "(var)tb:" conv="strpos:<TBODY>,{bg}";
				if ('{bg}' >= 0) {
					lvl = 1;
					ed = -1;  // ed must be >= {bg} to split
					pos = "(expr){bg} + 7";
					while ('{pos}' < '{ln}') {
						tbclose = "(var)tb:" conv="strpos:</TBODY>,{pos}";
						tbopen = "(var)tb:" conv="strpos:<TBODY>,{pos}";
						if ('{tbclose}' > 0 && ('{tbopen}' < 0 || '{tbclose}' < '{tbopen}')) {
							// Got a close
							var lvl conv="--";
							if ('{lvl}' == 0) ed = "{tbclose}";
							pos = "(expr){tbclose} + 8";
						} else if ('{tbopen}' > 0 && ('{tbclose}' < 0 || '{tbopen}' < '{tbclose}')) {
							// Got an open
							var lvl conv="++";
							pos = "(expr){tbopen} + 7";
						} else {
							if ('{lvl}' > 0) ed = "{ln}";
							break;
						}
						// Got an inner pair; advance to after it
					}
					if ('{ed}' > '{bg}') {
						// Split it
						pos = "(expr){bg} + 7";
						TBODY:Before = "(var)tb:" conv="substr:0,{pos}";
						ln = "(expr){ed} - {pos}";
						TBODY = "(var)tb:" conv="substr:{pos},{ln}";
						TBODY:After = "(var)tb:" conv="substr:{ed}";
					}
				}
			}
		}
	}

	this%save (var)TBODY;
}


/*
 * load
 *	Load the TBODY array from scheme%tbody/ (or session%tbody_ in phantom mode),
 *	or, if no path, load from the file specified in arg%arg.
 */
function tbody_load
{
	global PortalObjectName;
	global {PortalObjectName}%;

	if ({#this%path:}) {
		if ('{{PortalObjectName}%Phantom}')
			this%TBODY = (var)session%tbody_{this%type}_{this%category}_{this%file}_TBODY;
		if ({#this%TBODY} < 3)
			this%TBODY = (var)scheme%tbody/{this%type}{this%category|precede:/}{this%file|precede:/}&TBODY;
	} else {
		fileArg = "{arg%file}";
		if ({#fileArg:} == 0) fileArg = "{arg%arg}";
		if ({#fileArg:}) {
			// Load from file
			output;
			include "{fileArg}";
			this%process (var)sys%output:content;
			output cancel;
		}
	}
	result%function = (var)this%TBODY;
}


/*
 * get
 *	Get the internal TBODY array: TBODY:Before, TBODY and TBODY:After.
 *	If not found internally to the tbody object, load it.
 */
function tbody_get
{
	if ({#this%TBODY} == 0) this%load "{arg%arg}" file="{arg%file}";
	result%function = (var)this%TBODY;
}


/*
 * save
 *	Set the internal TBODY array: TBODY:Before, TBODY and TBODY:After
 *	and store it to scheme%tbody/type/category/file&TBODY
 *	or session%tbody_... if in phantom mode
 *
 * arg%arg: The TBODY array
 */
function tbody_save
{
	this%TBODY = (var)arg%arg conv="unescape";
	if ({#this%path:}) {
		global PortalObjectName;
		global {PortalObjectName}%;
	
		if ('{{PortalObjectName}%Phantom}') {
			session%tbody_{this%type}_{this%category}_{this%file}_TBODY = (var)this%TBODY;
		} else {
			scheme%tbody/{this%type}{this%category|precede:/}{this%file|precede:/}&TBODY = (var)this%TBODY;
		}
	}
}


/*
 * gotTEA
 *	Return 1 if the last TEA editing was for text%tbody/type/category/file&TBODY
 *	or 0 if otherwise
 */
function tbody_gotTEA
{
	global PortalObjectName;
	global {PortalObjectName}%;

	result%function = 0;

	if ({#this%path:}) {
		//pageCode = "/{this%type}{this%category|precede:/}{this%file|precede:/}";
		pageCode = "/{this%path}";
		textCode = "{this%text}";
	
		sfx = "";
		if ('{{PortalObjectName}%Phantom}') sfx = "_Phantom";
		if ('{session%TextEdit:textcode}' == '{textCode}{sfx}'
			&& '{session%TextEdit:pagecode}' == '{pageCode}'
			&& '{session%TextEdit:itemcode}' == '')
			result%function = 1;
	}
}


/*
 * Find the available category along the parent path upward
 *	arg%category - The category to start looking (default to be this%category)
 *	arg%file - The scheme file containing the TB text (optional)
 *	arg%text - The text name (default TBODY)
 *	result%function - the found category (already set to this%category) or empty if not found
 */
function tbody_findcategory
{
	global PortalObjectName;
	global {PortalObjectName}%;

	// Note: result%text must be (var)ed to avoid evaluation
	if ({#this%path} == 0) return;

	// Find the available tbody along the parent path
	useFile = "{this%file|{PortalObjectName}%convPath}";
	useText = "{this%text}";
	useCat = "{this%category}";
	while (1) {
		//if ('{{PortalObjectName}%Phantom}') {PortalObjectName}%text "{this%type}{useCat|precede:/}{useFile}&{useText}" phantomget='text';
		//else result%text = (var)text%{{PortalObjectName}%TextSubdir}/{this%type}{useCat|precede:/}{useFile}&{useText};
		{PortalObjectName}%text "{this%type}{useCat|precede:/}{useFile}&{useText}" phantomget='text';
		if ({#result%text:} || {#useCat:} == 0) break;
		useCat = "{useCat|dirname}";
		if ('{useCat}' == '.') useCat = '';
	}
//debug%display = "useCat=[{useCat}]<br>\n";
	//if ({#useCat:} && '{useCat}' != '{arg%category}') this%category = "{useCat|{PortalObjectName}%convPath:,}{useFile}";
//debug%display = "this%category=[{this%category}]<br>\n";
//	if ({#useCat:}) {
		this%category = "{useCat|{PortalObjectName}%convPath:,}";
		result%function = (var)result%text;
//	}
}


/*
 * listTEACUP
 *	List the item in the text file based on the TBODY.
 *	arg%arg (or arg%text) is the text file.
 *	arg%textname is the text name in the text file.
 *	The function read the text and evaluate the variables in it,
 *	then display the TBODY with the variables.
 */
function tbody_listTEACUP
{
	global glob;

	global PortalObjectName;
	global {PortalObjectName}%;

	textFile = "{arg%arg}";
	if ({#textFile:} == 0) textFile = "{arg%text}";
	textFile = "{textFile|{PortalObjectName}%convPath}";
	textName = "{arg%textname}";
	if ({#textName:} == 0) textName = "{{PortalObjectName}%PageBodyName}:{{PortalObjectName}%TextItem}";

	_page = "{{PortalObjectName}%Subpath}{textFile}" conv="replacere:^/";
	_siteurl = "{{PortalObjectName}%SiteURL}";
	dummy = "";
	numNewValues = 0;
	numOldValues = "{#class%value}" conv=++;

	// To load the values: If Phantom but no text, still load page
	if ('{{PortalObjectName}%Phantom}') dummy = "{session%Phantom_Text:{textFile}&{textName}}";
	if ({#dummy:} == 0) dummy = "{text%{{PortalObjectName}%TextSubdir}{textFile}&{textName}}";
	numNewValues = "{#class%value}";
	// If new values have been defined in the dummy assignment
	if ({numNewValues} > {numOldValues}) {
		this%get;
		display "{this%TBODY|{PortalObjectName}%valueQuote}";
	}
}


/*
 * listTEAPOT
 *	List the item in the record based on the TBODY
 *	arg%arg (or arg%text) is the record.
 *	arg%page is the page number for the {page} variable in the TBODY.
 */
function tbody_listTEAPOT
{
	global glob;

	global PortalObjectName;
	global {PortalObjectName}%;

	rec = (var)arg%arg;
	page = (var)arg%page;

	if ({#rec}) {
		foreach (rec) {
			if ({#foreach:key}) "{foreach:key}" = "{foreach}";
		}
		this%get;
		display "{this%TBODY|{PortalObjectName}%valueQuote}";
	}
}
</script>
