<?php
if (!defined('INI_PHP')) {
define('INI_PHP', null);



//
// bee/php/bee/ini.php for Windows system
//
//    Please modify the parameters according to your needs.
//
//    If you are using QueenBEE, the settings in ~bee/etc/bee.conf are
//    not applicable as they are for the UNIX scripts under ~bee/bin only.
//


define('CROFT_SINGLE_EXPIRY',                  '1-Jan-2007');
define('CROFT_SINGLE_WEBSERVER',               'localhost');  // or your proper host name
define('CROFT_SINGLE_WEBPATH',                 '/');
define('CROFT_SINGLE_OWNER',                   'owner');
define('CROFT_SINGLE_SERVICE',                 'service');


// In the _DIR settings, ~ stands for the Document Root
define('INI_SITE_DIR',                         '~');
define('INI_WWW_DIR',                          '~');
define('INI_CUST_DIR',                         '~/bee/cust');
define('INI_FILE_DIR',                         '~/bee/cust');
define('INI_SCHEME_DIR',                       '~/bee/scheme');
define('INI_VB_DIR',                           '~/bee/vb');

// Alternatively, you may use absolute path for the _DIR setings.  The platform will
// substitute @owner and @service with the CROFT values at run time.
// (Please use '/' instead of '\' - BEE standardises on '/' and php will handle it nicely.)
//define('INI_SITE_DIR',                         'c:/Inetpub/wwwroot/@owner/site/@service');
//define('INI_WWW_DIR',                          'c:/Inetpub/wwwroot/@owner/site/@service/www');
//define('INI_CUST_DIR',                         'c:/Inetpub/wwwroot/@owner/site/@service/cust');
//define('INI_FILE_DIR',                         'c:/Inetpub/wwwroot/@owner/site/@service/cust');
//define('INI_SCHEME_DIR',                       'c:/Inetpub/wwwroot/@owner/site/@service/scheme');
//define('INI_VB_DIR',                           'c:/Inetpub/wwwroot/@owner/site/@service/vb');

// Other INIs
define('INI_MAX_EXECUTION_TIME',               '300');
define('INI_MEMORY_LIMIT',                     '64M');
define('INI_LOG_ERRORS',                       'Off');

define('INI_INCLUDE_PATH',                     '~;~/bee/include');


// Database settings

define('CROFT_SINGLE_DBTYPE',                  'mysql');
define('CROFT_SINGLE_DBHOST',                  'localhost');  // or your proper host name
define('CROFT_SINGLE_DBNAME',                  'mydbname');
define('CROFT_SINGLE_DBUSERNAME',              'mydbuser');
define('CROFT_SINGLE_DBPASSWORD',              'mydbpass');


// Authentication settings

define('CROFT_SINGLE_AUTH_DBTYPE',             'scheme');  // mysql if the passwords are in a database
define('CROFT_SINGLE_AUTH_DBHOST',             '');  // e.g. mydbhost.com if DBTYPE is not 'scheme'
define('CROFT_SINGLE_AUTH_DBNAME',             '');  // e.g. mydb if DBTYPE is not 'scheme'
define('CROFT_SINGLE_AUTH_DBTABLE',            'Auth');
define('CROFT_SINGLE_AUTH_PASSWORDTYPE',       '0');  // 0 for plain; 1 StdDES; 2 ExtDES; 3 MD5; 4 Blowfish
define('CROFT_SINGLE_AUTH_ADMINACCESSLEVEL',   '10');
define('CROFT_SINGLE_AUTH_DBUSERNAME',         '');  // The database access username if DBTYPE is mysql
define('CROFT_SINGLE_AUTH_DBPASSWORD',         '');  // The database access password if DBTYPE is mysql
define('CROFT_SINGLE_AUTH_USERNAMEFIELD',      'Username');
define('CROFT_SINGLE_AUTH_PASSWORDFIELD',      'Password');
define('CROFT_SINGLE_AUTH_REALMFIELD',         'Realm');
define('CROFT_SINGLE_AUTH_ACCESSLEVELFIELD',   'AccessLevel');
define('CROFT_SINGLE_AUTH_ACTIVEFIELD',        'Active');
define('CROFT_SINGLE_AUTH_EXPIRYFIELD',        'Expiry');


// The basename (folder name) of the source (src) and web (www) directory
define("BEE_BASENAME_WWW",                     '');
define("BEE_BASENAME_OBJ",                     'bee/obj');

define("BEE_BASENAME_SRC",                     'src');  // Obsolete - for backward compatibility


// Operating System specific parameters
define('INI_PATH_SLASH',                       '/');  // Always use '/' even for Windows
define('INI_PATH_SLASH_ALT',                   '\\');  // The alternative "slash" to look for during path normalization
define('INI_SHELL',                            'WINDOWS');


// Session Settings
//define("INI_SESSION_SAVE_PATH", 'c:\temp');

// For the exec command.  The script name will be in
// the format of owner+script.  If that owner script
// cannot be executed, common+script will be used instead.
// The following setting needs to be consistent with
// php.ini if safe_mode is on in PHP.
define("BEE_SAFE_MODE_EXEC_DIR",               'c:/php/exec');
define("BEE_SAFE_MODE_EXEC_DEFAULT_OWNER",     'common');

// BEE Script Settings
define("BEE_SCRIPT_LOOP_MAXITER",     '10000');
define("BEE_SCRIPT_DBTREE_MAXLEVELS", '10');
define("BEE_SCRIPT_DBTREE_MAXNODES",  '1000');

// Temp file prefix (the temp file name will be appended with the session ID)
define("BEE_TEMPFILE_PREFIX",                  'c:/temp/bee.');


// The following is experimental
define('SHOW_MORE_ERRORS',                     '');  // Boolean
define('DEBUG_IP',                             '');  // Core debugging only



}  // INI_PHP
?>
